#include <stdio.h>
//#include <windows.h>
#include "../tinygl/GL/gl.h"
#include "winlnxdefs.h"
#include "Gfx_#1.3.h"
#include "main.h"
#include "texture.h"

void (*dp_command[256])() =
{
   DP_NOOP       , DP_MTX           , DP_NI               , DP_MOVEMEM        ,
   DP_VTX        , DP_NI            , DP_DL               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_RDPHALF_CONT     , DP_RDPHALF_2      ,
   DP_RDPHALF_1  , DP_NI            , DP_CLEARGEOMETRYMODE, DP_SETGEOMETRYMODE,
   DP_ENDDL      , DP_SETOTHERMODE_L, DP_SETOTHERMODE_H   , DP_TEXTURE        ,
   DP_MOVEWORD   , DP_POPMTX        , DP_NI               , DP_TRI1           ,
   
   DP_NOOP       , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_NI         , DP_NI            , DP_NI               , DP_NI             ,
   DP_TEXRECT    , DP_NI            , DP_LOADSYNC         , DP_PIPESYNC       ,
   DP_TILESYNC   , DP_FULLSYNC      , DP_NI               , DP_NI             ,
   DP_NI         , DP_SETSCISSOR    , DP_SETPRIMDEPTH     , DP_SETOTHERMODE   ,
   DP_LOADTLUT   , DP_NI            , DP_SETTILESIZE      , DP_LOADBLOCK      ,
   DP_LOADTILE   , DP_SETTILE       , DP_FILLRECT         , DP_SETFILLCOLOR   ,
   DP_SETFOGCOLOR, DP_SETBLENDCOLOR , DP_SETPRIMCOLOR     , DP_SETENVCOLOR    ,
   DP_SETCOMBINE , DP_SETTIMG       , DP_SETZIMG          , DP_SETCIMG
};

void DP_NOOP()
{
}

void DP_NI()
{
}

void DP_TEXRECT()
{
	int w ,h, i;
	static unsigned long inst01, inst02;
	int ulx, uly, lrx, lry, tile;
	double s, t, dsdx, dtdy, scale_s, scale_t;

	inst01 = inst1;
	inst02 = *(RDP_PC+1);

	RDP_PC+=2;
	inst1 = *(RDP_PC+1);
	RDP_PC+=2;
	inst2 = *(RDP_PC+1);

	lrx = (inst01 & 0x00FFF000) >> 14;
	lry = (inst01 & 0x00000FFF) >> 2;
	ulx = (inst02 & 0x00FFF000) >> 14;
	uly = (inst02 & 0x00000FFF) >> 2;
   
	tile = (inst02 & 0x07000000) >> 24;
   
	s = (double)((short)((inst1 >> 16) & 0xFFFF)) / 32.0;
	t = (double)((short)(inst1 & 0xFFFF)) / 32.0;

	dsdx = (float)((short)((inst2 >> 16) & 0xFFFF)) / 1024.0;
	dtdy = (float)((short)(inst2 & 0xFFFF)) / 1024.0;
	
	if (rdp_Status.cycle_type == 2) dsdx /= 4;
	else {
		lrx--;
		lry--;
	}

	w = (int)(rdp_Status.tiles[tile].lrs - rdp_Status.tiles[tile].uls+1);
	h = (int)(rdp_Status.tiles[tile].lrt - rdp_Status.tiles[tile].ult+1);
	
	i=1;
	while (i<w) i*=2;
	rdp_Status.intern_w = i;
	i=1;
	while (i<h) i*=2;
	rdp_Status.intern_h = i;

	scale_s = rdp_Status.tiles[tile].shifts > 10 
		? (double)(1 << (16-rdp_Status.tiles[tile].shifts))
		: 1.0 / (double)(1 << rdp_Status.tiles[tile].shifts);
	scale_t = rdp_Status.tiles[tile].shiftt > 10 
		? (double)(1 << (16-rdp_Status.tiles[tile].shiftt))
		: 1.0 / (double)(1 << rdp_Status.tiles[tile].shiftt);
	
	load_texture(tile);
   
	glEnable(GL_TEXTURE_2D);
   

	glEnable(GL_ALPHA_TEST);
	//glAlphaFunc(GL_NOTEQUAL, 0.0);
 //TinyGL
	glColor3f(1.0, 1.0, 1.0);
	glDisable(GL_BLEND);

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

//	printf(" %f %f %f %f %f %f %f %f \n,"

	glBegin(GL_QUADS);
	glTexCoord2f(((s + (lrx-ulx)*dsdx)*scale_s)/rdp_Status.intern_w,
	 ( (t + (lry-uly)*dtdy)*scale_t)/rdp_Status.intern_h);
	glVertex2f((lrx-width/2)/((float)(width/2)),-(lry-height/2)/((float)(height/2)));
	glTexCoord2f(( s*scale_s)/rdp_Status.intern_w,
 ((t + (lry-uly)*dtdy)*scale_t)/rdp_Status.intern_h);
	glVertex2f((ulx-width/2)/((float)(width/2)),-(lry-height/2)/((float)(height/2)));
	glTexCoord2f(( s*scale_s)/rdp_Status.intern_w,
	 (t*scale_t)/rdp_Status.intern_h);
	glVertex2f((ulx-width/2)/((float)(width/2)),-(uly-height/2)/((float)(height/2)));
	glTexCoord2f(( (s + (lrx-ulx)*dsdx)*scale_s)/rdp_Status.intern_w,
	 ( t*scale_t)/rdp_Status.intern_h);
	glVertex2f((lrx-width/2)/((float)(width/2)),-(uly-height/2)/((float)(height/2)));
	glEnd();	

	/*glDisable(GL_TEXTURE_2D);

	glColor3ub(0.0, 0.0, 1.0);
	glBegin(GL_LINE_STRIP);
	glVertex2f((lrx-width/2)/((float)(width/2)),-(lry-height/2)/((float)(height/2)));
	glVertex2f((ulx-width/2)/((float)(width/2)),-(lry-height/2)/((float)(height/2)));
	glVertex2f((ulx-width/2)/((float)(width/2)),-(uly-height/2)/((float)(height/2)));
	glVertex2f((lrx-width/2)/((float)(width/2)),-(uly-height/2)/((float)(height/2)));
	glVertex2f((lrx-width/2)/((float)(width/2)),-(lry-height/2)/((float)(height/2)));
	glEnd();*/

	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}

void DP_LOADSYNC()
{
}

void DP_PIPESYNC()
{
}

void DP_TILESYNC()
{
}

void DP_FULLSYNC()
{
	/*SwapBuffers(hDC);
	glClearColor(0,0,0,0);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);*/
}

void DP_SETSCISSOR()
{
}

void DP_SETPRIMDEPTH()
{
}

void DP_SETOTHERMODE()
{
}

void DP_LOADTLUT()
{
	int tile;
	int count, addr, i;
	char stemp[100];
	inst2 = *(RDP_PC+1);

	count = ((inst2 >> 14) & 0x03FF) + 1;
	tile = (inst2 >> 24) & 0x07;
	addr = rdp_Status.tiles[tile].tmem/8 - 256;
	sprintf(stemp, "%d,%d", count, addr);
	for (i=addr*2; i<(addr+count)*2; i++)
	{
		rdp_Status.palette_crc[16] -= rdp_Status.palette[i];
		rdp_Status.palette_crc[i/16] -= rdp_Status.palette[i];
		rdp_Status.palette[i] = rdp_Status.timg_addr[i+addr*2];
		rdp_Status.palette_crc[16] += rdp_Status.palette[i];
		rdp_Status.palette_crc[i/16] += rdp_Status.palette[i];
	}
}

void DP_SETTILESIZE()
{
	int tile;
	inst2 = *(RDP_PC+1);

	tile = (inst2 >> 24) & 0x07;
	rdp_Status.tiles[tile].uls = ((inst1 >> 12) & 0xFFF) / 4.0;
	rdp_Status.tiles[tile].ult = (inst1 & 0xFFF) / 4.0;
	rdp_Status.tiles[tile].lrs = ((inst2 >> 12) & 0xFFF) / 4.0;
	rdp_Status.tiles[tile].lrt = (inst2 & 0xFFF) / 4.0;
}

void DP_LOADBLOCK()
{
	int tile/*, i*/;

	inst2 = *(RDP_PC+1);
   
	tile = (inst2 >> 24) & 0x07;
	rdp_Status.tiles[tile].uls = ((inst1 >> 12) & 0xFFF) / 4.0;
	rdp_Status.tiles[tile].ult = (inst1 & 0xFFF) / 4.0;
	rdp_Status.tiles[tile].lrs = ((inst2 >> 12) & 0xFFF) / 4.0;
	rdp_Status.timg_block_size = (inst2 >> 12) & 0xFFF;
	rdp_Status.timg_dxt = inst2 & 0xFFF;
	
	/*memcpy(rdp_status.tiles[tile].tmem, 
		rdp_status.timg_addr,
		lrs*2);*/
	//rdp_status.tiles[tile].tmem = rdp_status.timg_addr;
	/*rdp_status.timg_crc = 0;
	for (i=0; i<(rdp_status.timg_block_size*
		rdp_status.tiles[tile].size == 0 ? 0.5 : rdp_status.tiles[tile].size); i++)
		rdp_status.timg_crc += (unsigned int)(((unsigned char *)rdp_status.timg_addr)[i]);*/
}

void DP_LOADTILE()
{
	printf("LoadTile\n");
}

void DP_SETTILE()
{
	int tile;
	inst2 = *(RDP_PC+1);
   
	tile = (inst2 >> 24) & 0x07;
	rdp_Status.tiles[tile].format = (inst1 >> 21) & 0x07;
	rdp_Status.tiles[tile].size = (inst1 >> 19) & 0x03;
	rdp_Status.tiles[tile].line = (inst1 >> 9) & 0x1FF;
	//rdp_status.tiles[tile].tmem = rdp_status.tmem + (inst1 & 0x1FF)*8;
	rdp_Status.tiles[tile].tmem = (inst1 & 0x1FF)*8;
	rdp_Status.tiles[tile].tmem_addr = rdp_Status.timg_addr + rdp_Status.tiles[tile].tmem;
	rdp_Status.tiles[tile].palette = (inst2 >> 20) & 0xF;
	rdp_Status.tiles[tile].cmt = (inst2 >> 18) & 0x03;
	rdp_Status.tiles[tile].maskt = (inst2 >> 14) & 0x0F;
	rdp_Status.tiles[tile].shiftt = (inst2 >> 10) & 0x0F;
	rdp_Status.tiles[tile].cms = (inst2 >> 8) & 0x03;
	rdp_Status.tiles[tile].masks = (inst2 >> 4) & 0x0F;
	rdp_Status.tiles[tile].shifts = inst2 & 0x0F;
}

void DP_FILLRECT()
{
}

void DP_SETFILLCOLOR()
{
}

void DP_SETFOGCOLOR()
{
}

void DP_SETBLENDCOLOR()
{
}

void DP_SETPRIMCOLOR()
{
}

void DP_SETENVCOLOR()
{
}

void DP_SETCOMBINE()
{
}

void DP_SETTIMG()
{
	inst2 = *(RDP_PC+1);
   
	rdp_Status.timg_fmt = (inst1 & 0x00E00000) >> 21;
	rdp_Status.timg_size = (inst1 & 0x00180000) >> 19;
	rdp_Status.timg_width = (inst1 & 0xFFF)+1;
	rdp_Status.timg_addr = (unsigned char*)gfx_Info.RDRAM + 
		rdp_Status.segment[(inst2 >> 24) & 0xF] + (inst2 & 0xFFFFFF);
}

void DP_SETZIMG()
{
}

void DP_SETCIMG()
{
}

