#ifndef NGLX_H
#define NGLX_H

#include <SDL/SDL.h>
#include "gl.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void *NGLXContext;
typedef int NGLXDrawable;

extern NGLXContext nglXCreateContext( NGLXContext shareList, int flags );

extern void nglXDestroyContext( NGLXContext ctx );

extern int nglXMakeCurrent( NGLXDrawable drawable,
			    NGLXContext ctx);

extern void nglXSwapBuffers( void );

#ifdef __cplusplus
}
#endif

#endif
